ls(1)

NAME
ls - list directory contents

SYNOPSIS
ls [-1ACFLRSTWacdfgiklmnopqrstux] [file ...]

DESCRIPTION
For each operand that names a file of a type other than directory, ls displays its name as well as any requested, associated information. For each operand that names a file of type directory, ls displays the names of files contained within that directory, as well as any requested, associated information.

If no operands are given, the contents of the current directory are displayed. If more than one operand is given, non-directory operands are displayed first; directory and non-directory operands are sorted separately and in lexicographical order.

The options are as follows:

-A  List all entries except for “”. and “..”. Always set for the super-user.

-C  Force multi-column output; this is the default when output is to a terminal.

-F  Display a slash (‘/’) immediately after each pathname that is a directory, an asterisk (‘*’) after each that is executable, an at sign (‘@’) after each symbolic link, a percent sign (‘%’) after each whiteout, an equal sign (‘=’) after each socket, and a vertical bar (‘|’) after each that is a FIFO.

-L  If argument is a symbolic link, list the file or directory the link references rather than the link itself.

-R  Recursively list subdirectories encountered.

-S  Sort by size, largest file first.

-T  Display complete time information for the file, including month, day, hour, minute, second, and year. This option has no effect unless one of the long format (-l, -n) options is also specified.

-W  Display whiteouts when scanning directories.

-a  Include directory entries whose names begin with a dot (‘’)..

-c  Use time file's status was last changed instead of last modification time for sorting (-t) or printing (-l, -n).

-d  Directories are listed as plain files (not searched recursively) and symbolic links in the argument list are not indirected through.

-f  Output is not sorted.

-g  Does nothing; kept for compatibility with older versions of ls(1).

-i  For each file, print its inode number.

-k  Modifies the -s option, causing the sizes to be reported in kilobytes. Overrides any value specified by the BLOCKSIZE environment variable.

-l  (The lowercase letter “ell.”) List in long format (see below). If the output is to a terminal, a total sum of all file sizes is output on a line before the long listing.

-m  Stream output format; list files across the page, separated by commas.

-n  List in long format as in -l, but retain user and group IDs in a numeric format.

-o  Include the file flags in a long format (-l, -n) output.

-p  Display a slash (‘/’) immediately after each pathname that is a directory.

-q  Force printing of non-graphic characters in file names as the character “”?; this is the default when output is to a terminal.

-r  Reverse the order of the sort to get reverse lexicographical order or the smallest or oldest entries first.

-s  Display the number of file system blocks actually used by each file, where partial units are rounded up to the next integer value. Blocks are 512 bytes unless overridden by the -k flag or BLOCKSIZE environment variable.

-t  Sort by time modified (most recently modified first) before sorting the operands in lexicographical order.

-u  Use file's last access time instead of last modification time for sorting (-t) or printing (-l, -n).

-x  Multi-column output sorted across the page rather than down the page.

-1  (The numeric digit “one.”) Force output to be one entry per line. This is the default when output is not to a terminal.

The -1, -C, -l, and -n options all override each other; the last one specified determines the format used.

The -c and -u options override each other; the last one specified determines the file time used. The -f option overrides any occurrence of either.

By default, ls lists one entry per line to standard output; the exceptions are to terminals or when the -C or -m options are specified.

File information is displayed with one or more <blank>s separating the information associated with the -i, -s, -l, and -n options.

  The Long Format
If the -l or -n options are given, the following information is displayed for each file: mode, number of links, owner, group, size in bytes, time of last modification (“mmm dd HH:MM”), and the pathname. In addition, for each directory whose contents are displayed, the first line displayed is the total number of blocks used by the files in the directory. Blocks are 512 bytes unless overridden by the -k option or BLOCKSIZE environment variable.

If the owner or group name is not a known user or group name, respectively, or the -n option is given, the numeric ID is displayed.

If the file is a character special or block special file, the major and minor device numbers for the file are displayed in the size field.

If the -T option is given, the time of last modification is displayed using the format “mmm dd HH:MM:SS CCYY”.

If the file is a symbolic link, the pathname of the linked-to file is preceded by “->”.

The file mode printed under the -l or -n options consists of the entry type, owner permissions, and group permissions. The entry type character describes the type of file, as follows:

b   block special file
c   character special file
d   directory
l   symbolic link
s   socket link
p   FIFO
w   whiteout
-   regular file

The next three fields are three characters each: owner permissions, group permissions, and other permissions. Each field has three character positions:

1.  If r, the file is readable; if -, it is not readable.
2.  If w, the file is writable; if -, it is not writable.
3.  The first of the following that applies:

    S   If in the owner permissions, the file is not executable and set-user-ID mode is set. If in the group permissions, the file is not executable and set-group-ID mode is set.

    s   If in the owner permissions, the file is executable and set-user-ID mode is set. If in the group permissions, the file is executable and setgroup-ID mode is set.

    x   The file is executable or the directory is searchable.

    -   The file is neither readable, writable, executable, nor set-user-ID, nor set-group-ID, nor sticky (see below).

    These next two apply only to the third character in the last group (other permissions):

    T   The sticky bit is set (mode 1000), but neither executable nor searchable (see chmod(1) or sticky(8)).

    t   The sticky bit is set (mode 1000), and is searchable or executable (see chmod(1) or sticky(8)).

In addition, if the -o option is specified, the file flags (see chflags(1)) are displayed as comma-separated strings in front of the file size, abbreviated as follows:

-   no flags
uappnd
    user append-only
uchg
    user immutable
nodump
    do not dump
opaque
    opaque file
sappnd
    system append-only
arch
    archived
schg
    system immutable

The ls utility exits 0 on success or >0 if an error occurred.

ENVIRONMENT
The following environment variables affect the execution of ls:

BLOCKSIZE
    If the environment variable BLOCKSIZE is set, and the -k option is not specified, the block counts (see -s) will be displayed in units of that size block.

COLUMNS
    If this variable contains a string representing a decimal integer, it is used as the column position width for displaying multiple-text-column output. The ls utility calculates how many pathname text columns to display based on the width provided (see -C).

TZ  The timezone to use when displaying dates. See environ(7) for more information.

COMPATIBILITY
The group field is now automatically included in the long listing for files in order to be compatible with the p1003.2 specification.

SEE ALSO
chflags(1), chmod(1), symlink(7), sticky(8)

HISTORY
An ls utility appeared in AT&T UNIX.

STANDARDS
The ls utility is expected to be a superset of the p1003.2 specification.